version: 1

{% if plugins.bitcoin.info.network == "mainnet" %}
{% set network = "bitcoin" %}
{% else %}
{% set network = plugins.bitcoin.info.network %}
{% endif %}

containers:
  main:
    image: ghcr.io/elementsproject/cln-application:0.0.5@sha256:5125fc784564997d4d047cb99378284f57eb4900ebc39bdd9ab56811a4763312
    port: 8080
    command: npm run start
    mounts:
      data:
        web-ui/config: /config
        cln/data: /cln-data
        certs/certs: /rest-certs
    environment:
      APP_CORE_LIGHTNING_PORT: 8080
      APP_CORE_LIGHTNING_BITCOIN_NETWORK: {{ network }}
      APP_CORE_LIGHTNING_DAEMON_IP: ln.core-lightning.{{user}}.nirvati
      APP_CORE_LIGHTNING_DAEMON_GRPC_PORT: 31215
      APP_CORE_LIGHTNING_WEBSOCKET_PORT: 31214
      APP_CORE_LIGHTNING_REST_PORT: 31216
      APP_CORE_LIGHTNING_REST_CERT_DIR: /rest-certs
      APP_CORE_LIGHTNING_REST_HIDDEN_SERVICE:
        secret: onion-svc-api-domain
        key: domain
      CORE_LIGHTNING_PATH: /cln-data
      COMMANDO_CONFIG: /cln-data/.commando-env
      APP_CONFIG_DIR: /config
      APP_MODE: production
      DEVICE_DOMAIN_NAME: TODO.nirvati
      LOCAL_HOST: http://TODO.nirvati
      CA_CERT: /cln-data/{{ network }}/ca.pem
      CLIENT_KEY: /cln-data/{{ network }}/client-key.pem
      CLIENT_CERT: /cln-data/{{ network }}/client.pem

  ln:
    image: elementsproject/lightningd:v24.05@sha256:fc02cfbf0921ab731d8b680db9d1f85b7dbb3b57db596c6dd400659678e5770b
    mounts:
      data:
        web-ui/config: /config
        cln/data: /cln-data
    internal_ports:
      9735: 9735 # Lightning
      31214: 31214 # WS
      31215: 31215 # GRPC
      31216: 31216 # REST
    command:
      - --bitcoin-rpcconnect=gateway.bitcoin.{{user}}.nirvati
      - --bitcoin-rpcuser=core-lightning-{{user}}-cln
      - --bitcoin-rpcpassword={{ plugins.bitcoin.info.account_passwords.cln }}
      - --bitcoin-rpcport=8332
      - --lightning-dir=/cln-data
      - --proxy=proxy.tor.nirvati:9050
      - --bind-addr=0.0.0.0:9735
      - --bind-addr=ws:0.0.0.0:31214
      - --grpc-port=31215
      - --clnrest-host=0.0.0.0
      - --clnrest-port=31216
      - --addr=$(ONION_SVC_NAME)
      - --network={{ network }}
      - --database-upgrade=true
      - --experimental-offers
    environment:
      ONION_SVC_NAME:
        secret: onion-svc-p2p-domain
        key: domain

tor:
  onion-service:
    p2p:
      target_svc: ln
      ports:
        9735: 9735
      store_name_in_secret:
        name: onion-svc-p2p-domain
        key: domain
    api:
      target_svc: ln
      ports:
        31214: 31214 # WS
        31215: 31215 # GRPC
        31216: 31216 # REST
      store_name_in_secret:
        name: onion-svc-api-domain
        key: domain

